Code

git am --abort
[git.git] / git-am.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005, 2006 Junio C Hamano
5 SUBDIRECTORY_OK=Yes
6 OPTIONS_KEEPDASHDASH=
7 OPTIONS_SPEC="\
8 git-am [options] [<mbox>|<Maildir>...]
9 git-am [options] --resolved
10 git-am [options] --skip
11 --
12 d,dotest=       (removed -- do not use)
13 i,interactive   run interactively
14 b,binary        pass --allow-binary-replacement to git-apply
15 3,3way          allow fall back on 3way merging if needed
16 s,signoff       add a Signed-off-by line to the commit message
17 u,utf8          recode into utf8 (default)
18 k,keep          pass -k flag to git-mailinfo
19 whitespace=     pass it through git-apply
20 C=              pass it through git-apply
21 p=              pass it through git-apply
22 resolvemsg=     override error message when patch failure occurs
23 r,resolved      to be used after a patch failure
24 skip            skip the current patch
25 abort           restore the original branch and abort the patching operation.
26 rebasing        (internal use for git-rebase)"
28 . git-sh-setup
29 prefix=$(git rev-parse --show-prefix)
30 set_reflog_action am
31 require_work_tree
32 cd_to_toplevel
34 git var GIT_COMMITTER_IDENT >/dev/null ||
35         die "You need to set your committer info first"
37 stop_here () {
38     echo "$1" >"$dotest/next"
39     exit 1
40 }
42 stop_here_user_resolve () {
43     if [ -n "$resolvemsg" ]; then
44             printf '%s\n' "$resolvemsg"
45             stop_here $1
46     fi
47     cmdline=$(basename $0)
48     if test '' != "$interactive"
49     then
50         cmdline="$cmdline -i"
51     fi
52     if test '' != "$threeway"
53     then
54         cmdline="$cmdline -3"
55     fi
56     echo "When you have resolved this problem run \"$cmdline --resolved\"."
57     echo "If you would prefer to skip this patch, instead run \"$cmdline --skip\"."
58     echo "To restore the original branch and stop patching run \"$cmdline --abort\"."
60     stop_here $1
61 }
63 go_next () {
64         rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
65                 "$dotest/patch" "$dotest/info"
66         echo "$next" >"$dotest/next"
67         this=$next
68 }
70 cannot_fallback () {
71         echo "$1"
72         echo "Cannot fall back to three-way merge."
73         exit 1
74 }
76 fall_back_3way () {
77     O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
79     rm -fr "$dotest"/patch-merge-*
80     mkdir "$dotest/patch-merge-tmp-dir"
82     # First see if the patch records the index info that we can use.
83     git apply --build-fake-ancestor "$dotest/patch-merge-tmp-index" \
84         "$dotest/patch" &&
85     GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
86     git write-tree >"$dotest/patch-merge-base+" ||
87     cannot_fallback "Repository lacks necessary blobs to fall back on 3-way merge."
89     echo Using index info to reconstruct a base tree...
90     if GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
91         git apply $binary --cached <"$dotest/patch"
92     then
93         mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
94         mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
95     else
96         cannot_fallback "Did you hand edit your patch?
97 It does not apply to blobs recorded in its index."
98     fi
100     test -f "$dotest/patch-merge-index" &&
101     his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git write-tree) &&
102     orig_tree=$(cat "$dotest/patch-merge-base") &&
103     rm -fr "$dotest"/patch-merge-* || exit 1
105     echo Falling back to patching base and 3-way merge...
107     # This is not so wrong.  Depending on which base we picked,
108     # orig_tree may be wildly different from ours, but his_tree
109     # has the same set of wildly different changes in parts the
110     # patch did not touch, so recursive ends up canceling them,
111     # saying that we reverted all those changes.
113     eval GITHEAD_$his_tree='"$FIRSTLINE"'
114     export GITHEAD_$his_tree
115     git-merge-recursive $orig_tree -- HEAD $his_tree || {
116             git rerere
117             echo Failed to merge in the changes.
118             exit 1
119     }
120     unset GITHEAD_$his_tree
123 prec=4
124 dotest="$GIT_DIR/rebase"
125 sign= utf8=t keep= skip= interactive= resolved= binary= rebasing= abort=
126 resolvemsg= resume=
127 git_apply_opt=
129 while test $# != 0
130 do
131         case "$1" in
132         -i|--interactive)
133                 interactive=t ;;
134         -b|--binary)
135                 binary=t ;;
136         -3|--3way)
137                 threeway=t ;;
138         -s|--signoff)
139                 sign=t ;;
140         -u|--utf8)
141                 utf8=t ;; # this is now default
142         --no-utf8)
143                 utf8= ;;
144         -k|--keep)
145                 keep=t ;;
146         -r|--resolved)
147                 resolved=t ;;
148         --skip)
149                 skip=t ;;
150         --abort)
151                 abort=t ;;
152         --rebasing)
153                 rebasing=t threeway=t keep=t binary=t ;;
154         -d|--dotest)
155                 die "-d option is no longer supported.  Do not use."
156                 ;;
157         --resolvemsg)
158                 shift; resolvemsg=$1 ;;
159         --whitespace)
160                 git_apply_opt="$git_apply_opt $1=$2"; shift ;;
161         -C|-p)
162                 git_apply_opt="$git_apply_opt $1$2"; shift ;;
163         --)
164                 shift; break ;;
165         *)
166                 usage ;;
167         esac
168         shift
169 done
171 # If the dotest directory exists, but we have finished applying all the
172 # patches in them, clear it out.
173 if test -d "$dotest" &&
174    last=$(cat "$dotest/last") &&
175    next=$(cat "$dotest/next") &&
176    test $# != 0 &&
177    test "$next" -gt "$last"
178 then
179    rm -fr "$dotest"
180 fi
182 if test -d "$dotest"
183 then
184         case "$#,$skip$resolved$abort" in
185         0,*t*)
186                 # Explicit resume command and we do not have file, so
187                 # we are happy.
188                 : ;;
189         0,)
190                 # No file input but without resume parameters; catch
191                 # user error to feed us a patch from standard input
192                 # when there is already $dotest.  This is somewhat
193                 # unreliable -- stdin could be /dev/null for example
194                 # and the caller did not intend to feed us a patch but
195                 # wanted to continue unattended.
196                 tty -s
197                 ;;
198         *)
199                 false
200                 ;;
201         esac ||
202         die "previous rebase directory $dotest still exists but mbox given."
203         resume=yes
205         case "$abort" in
206         t)
207                 git rerere clear
208                 git read-tree --reset -u HEAD ORIG_HEAD
209                 git reset ORIG_HEAD
210                 rm -fr "$dotest"
211                 exit ;;
212         esac
213 else
214         # Make sure we are not given --skip, --resolved, nor --abort
215         test "$skip$resolved$abort" = "" ||
216                 die "Resolve operation not in progress, we are not resuming."
218         # Start afresh.
219         mkdir -p "$dotest" || exit
221         if test -n "$prefix" && test $# != 0
222         then
223                 first=t
224                 for arg
225                 do
226                         test -n "$first" && {
227                                 set x
228                                 first=
229                         }
230                         case "$arg" in
231                         /*)
232                                 set "$@" "$arg" ;;
233                         *)
234                                 set "$@" "$prefix$arg" ;;
235                         esac
236                 done
237                 shift
238         fi
239         git mailsplit -d"$prec" -o"$dotest" -b -- "$@" > "$dotest/last" ||  {
240                 rm -fr "$dotest"
241                 exit 1
242         }
244         # -b, -s, -u, -k and --whitespace flags are kept for the
245         # resuming session after a patch failure.
246         # -3 and -i can and must be given when resuming.
247         echo "$binary" >"$dotest/binary"
248         echo " $ws" >"$dotest/whitespace"
249         echo "$sign" >"$dotest/sign"
250         echo "$utf8" >"$dotest/utf8"
251         echo "$keep" >"$dotest/keep"
252         echo 1 >"$dotest/next"
253         if test -n "$rebasing"
254         then
255                 : >"$dotest/rebasing"
256         else
257                 : >"$dotest/applying"
258                 git update-ref ORIG_HEAD HEAD
259         fi
260 fi
262 case "$resolved" in
263 '')
264         files=$(git diff-index --cached --name-only HEAD --) || exit
265         if [ "$files" ]; then
266            echo "Dirty index: cannot apply patches (dirty: $files)" >&2
267            exit 1
268         fi
269 esac
271 if test "$(cat "$dotest/binary")" = t
272 then
273         binary=--allow-binary-replacement
274 fi
275 if test "$(cat "$dotest/utf8")" = t
276 then
277         utf8=-u
278 else
279         utf8=-n
280 fi
281 if test "$(cat "$dotest/keep")" = t
282 then
283         keep=-k
284 fi
285 ws=`cat "$dotest/whitespace"`
286 if test "$(cat "$dotest/sign")" = t
287 then
288         SIGNOFF=`git-var GIT_COMMITTER_IDENT | sed -e '
289                         s/>.*/>/
290                         s/^/Signed-off-by: /'
291                 `
292 else
293         SIGNOFF=
294 fi
296 last=`cat "$dotest/last"`
297 this=`cat "$dotest/next"`
298 if test "$skip" = t
299 then
300         git rerere clear
301         this=`expr "$this" + 1`
302         resume=
303 fi
305 if test "$this" -gt "$last"
306 then
307         echo Nothing to do.
308         rm -fr "$dotest"
309         exit
310 fi
312 while test "$this" -le "$last"
313 do
314         msgnum=`printf "%0${prec}d" $this`
315         next=`expr "$this" + 1`
316         test -f "$dotest/$msgnum" || {
317                 resume=
318                 go_next
319                 continue
320         }
322         # If we are not resuming, parse and extract the patch information
323         # into separate files:
324         #  - info records the authorship and title
325         #  - msg is the rest of commit log message
326         #  - patch is the patch body.
327         #
328         # When we are resuming, these files are either already prepared
329         # by the user, or the user can tell us to do so by --resolved flag.
330         case "$resume" in
331         '')
332                 git mailinfo $keep $utf8 "$dotest/msg" "$dotest/patch" \
333                         <"$dotest/$msgnum" >"$dotest/info" ||
334                         stop_here $this
336                 # skip pine's internal folder data
337                 grep '^Author: Mail System Internal Data$' \
338                         <"$dotest"/info >/dev/null &&
339                         go_next && continue
341                 test -s "$dotest/patch" || {
342                         echo "Patch is empty.  Was it split wrong?"
343                         stop_here $this
344                 }
345                 if test -f "$dotest/rebasing" &&
346                         commit=$(sed -e 's/^From \([0-9a-f]*\) .*/\1/' \
347                                 -e q "$dotest/$msgnum") &&
348                         test "$(git cat-file -t "$commit")" = commit
349                 then
350                         git cat-file commit "$commit" |
351                         sed -e '1,/^$/d' >"$dotest/msg-clean"
352                 else
353                         SUBJECT="$(sed -n '/^Subject/ s/Subject: //p' "$dotest/info")"
354                         case "$keep_subject" in -k)  SUBJECT="[PATCH] $SUBJECT" ;; esac
356                         (printf '%s\n\n' "$SUBJECT"; cat "$dotest/msg") |
357                                 git stripspace > "$dotest/msg-clean"
358                 fi
359                 ;;
360         esac
362         GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
363         GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
364         GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
366         if test -z "$GIT_AUTHOR_EMAIL"
367         then
368                 echo "Patch does not have a valid e-mail address."
369                 stop_here $this
370         fi
372         export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
374         case "$resume" in
375         '')
376             if test '' != "$SIGNOFF"
377             then
378                 LAST_SIGNED_OFF_BY=`
379                     sed -ne '/^Signed-off-by: /p' \
380                     "$dotest/msg-clean" |
381                     sed -ne '$p'
382                 `
383                 ADD_SIGNOFF=`
384                     test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
385                     test '' = "$LAST_SIGNED_OFF_BY" && echo
386                     echo "$SIGNOFF"
387                 }`
388             else
389                 ADD_SIGNOFF=
390             fi
391             {
392                 if test -s "$dotest/msg-clean"
393                 then
394                         cat "$dotest/msg-clean"
395                 fi
396                 if test '' != "$ADD_SIGNOFF"
397                 then
398                         echo "$ADD_SIGNOFF"
399                 fi
400             } >"$dotest/final-commit"
401             ;;
402         *)
403                 case "$resolved$interactive" in
404                 tt)
405                         # This is used only for interactive view option.
406                         git diff-index -p --cached HEAD -- >"$dotest/patch"
407                         ;;
408                 esac
409         esac
411         resume=
412         if test "$interactive" = t
413         then
414             test -t 0 ||
415             die "cannot be interactive without stdin connected to a terminal."
416             action=again
417             while test "$action" = again
418             do
419                 echo "Commit Body is:"
420                 echo "--------------------------"
421                 cat "$dotest/final-commit"
422                 echo "--------------------------"
423                 printf "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
424                 read reply
425                 case "$reply" in
426                 [yY]*) action=yes ;;
427                 [aA]*) action=yes interactive= ;;
428                 [nN]*) action=skip ;;
429                 [eE]*) git_editor "$dotest/final-commit"
430                        action=again ;;
431                 [vV]*) action=again
432                        LESS=-S ${PAGER:-less} "$dotest/patch" ;;
433                 *)     action=again ;;
434                 esac
435             done
436         else
437             action=yes
438         fi
439         FIRSTLINE=$(sed 1q "$dotest/final-commit")
441         if test $action = skip
442         then
443                 go_next
444                 continue
445         fi
447         if test -x "$GIT_DIR"/hooks/applypatch-msg
448         then
449                 "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
450                 stop_here $this
451         fi
453         printf 'Applying %s\n' "$FIRSTLINE"
455         case "$resolved" in
456         '')
457                 git apply $git_apply_opt $binary --index "$dotest/patch"
458                 apply_status=$?
459                 ;;
460         t)
461                 # Resolved means the user did all the hard work, and
462                 # we do not have to do any patch application.  Just
463                 # trust what the user has in the index file and the
464                 # working tree.
465                 resolved=
466                 git diff-index --quiet --cached HEAD -- && {
467                         echo "No changes - did you forget to use 'git add'?"
468                         stop_here_user_resolve $this
469                 }
470                 unmerged=$(git ls-files -u)
471                 if test -n "$unmerged"
472                 then
473                         echo "You still have unmerged paths in your index"
474                         echo "did you forget to use 'git add'?"
475                         stop_here_user_resolve $this
476                 fi
477                 apply_status=0
478                 git rerere
479                 ;;
480         esac
482         if test $apply_status = 1 && test "$threeway" = t
483         then
484                 if (fall_back_3way)
485                 then
486                     # Applying the patch to an earlier tree and merging the
487                     # result may have produced the same tree as ours.
488                     git diff-index --quiet --cached HEAD -- && {
489                         echo No changes -- Patch already applied.
490                         go_next
491                         continue
492                     }
493                     # clear apply_status -- we have successfully merged.
494                     apply_status=0
495                 fi
496         fi
497         if test $apply_status != 0
498         then
499                 echo Patch failed at $msgnum.
500                 stop_here_user_resolve $this
501         fi
503         if test -x "$GIT_DIR"/hooks/pre-applypatch
504         then
505                 "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
506         fi
508         tree=$(git write-tree) &&
509         parent=$(git rev-parse --verify HEAD) &&
510         commit=$(git commit-tree $tree -p $parent <"$dotest/final-commit") &&
511         git update-ref -m "$GIT_REFLOG_ACTION: $FIRSTLINE" HEAD $commit $parent ||
512         stop_here $this
514         if test -x "$GIT_DIR"/hooks/post-applypatch
515         then
516                 "$GIT_DIR"/hooks/post-applypatch
517         fi
519         go_next
520 done
522 git gc --auto
524 rm -fr "$dotest"